#import <Quartz/Quartz.h>

@interface TapControlPlugIn : QCPlugIn
{
	/* Input taps */
	NSMutableArray*				_tapTimes; //Array of wrapped NSTimeIntervals representing the time of each beat
	BOOL						_stillDown;
	
	/* Estimator */
	NSTimeInterval				_estimatorPeriod;
	NSTimeInterval				_estimatorOffset;
	
	/* Output is a PLL locked to the estimator so the signal is continuous */
	NSTimeInterval				_pllPeriod;
	NSTimeInterval				_pllLastExecuteTime;
	double						_pllLastExecutePhase;
}

/* Declare a property input port of type "Boolean" and with the key "inputTap" */
@property BOOL inputTap;

/* Declare a property input port of type "Boolean" and with the key "inputReset" */
@property BOOL inputReset;

/* Declare a property input port of type "Number" and with the key "inputCorrectionFactor" */
@property double inputCorrectionFactor;

/* Declare a property output port of type "Number" and with the key "outputEstimatorPhase" */
@property double outputEstimatorPhase;

/* Declare a property output port of type "Number" and with the key "outputEstimatorPeriod" */
@property double outputEstimatorPeriod;

/* Declare a property output port of type "Number" and with the key "outputPLLPhase" */
@property double outputPLLPhase;

/* Declare a property output port of type "Number" and with the key "outputPLLPeriod" */
@property double outputPLLPeriod;

@end
